'' ****************************
'' *  HC4LED                  *
'' *  (C) 2006 Parallax, Inc  *
'' ****************************
''
'' Author.... Jon Williams (based on work by Terry Hitt and Dan Miller)
'' Updated... 15 MAY 2006


VAR

  long  started, clk, dta
  byte  segs[4] 
  

OBJ

  io    : "shiftio"  

  
PUB start(cpin, dpin)

  clk := cpin                                           ' save pins
  dta := dpin
  cls                                                   ' clear   
  started~~                                             ' mark started


PUB stop

  if started
    cls
    dira[clk]~
    dira[dta]~
    started~
  

PUB cls

  if started
    bytefill(@segs, 0, 4)
    update
    

PUB str(strAddr) | idx, c

  if started
    bytefill(@segs, 0, 4)
    repeat idx from 0 to 3
      c := byte[strAddr++]
      if c == 0
        quit
      else
        segs[idx] := Ascii32[c - 32]

    update
  

PUB dec(value) | idx, dig

'' displays decimal value from -999 to 9999 (truncates outside this range)

  if started
    bytefill(@segs, 0, 4)
    if value < 0
      -value
      value //= 1_000
      repeat idx from 3 to 1
        dig := value // 10
        segs[idx] := Ascii32[dig + "0" - 32]
        value /= 10
        if value == 0
          segs[--idx] := Ascii32["-" - 32]
          quit
    else
      value //= 10_000
      repeat idx from 3 to 0
        dig := value // 10
        segs[idx] := Ascii32[dig + "0" - 32]
        value /= 10 
        if value == 0
          quit

    update
  

PUB hex(value, digits) | idx, dig

'' displays hex value from $0 to $FFFF (truncates if greater)

  if started
    bytefill(@segs, 0, 4)
    digits := 1 #> digits <# 4
    idx := 3
    repeat digits
      dig := lookupz(value & $F : "0".."9", "AbCdEF")
      segs[idx--] := Ascii32[dig - 32]
      value >>= 4

    update


PUB bin(value, digits) | idx, dig

'' displays binary value from %0 to %1111 (truncates if greater) 

  if started
    bytefill(@segs, 0, 4)
    digits := 1 #> digits <# 4
    idx := 3
    repeat digits
      dig := (value & 1) + "0"
      segs[idx--] := Ascii32[dig - 32]
      value >>= 1

    update
    
  
PRI update | idx

  repeat idx from 3 to 0
    outa[clk]~~
    io.shiftout(dta, clk, io#MSB_FIRST, segs[idx], 8)


DAT  
                        ' edcbafg
  Ascii32     byte      %00000000               ' space (#32)
              byte      %00001010               ' !
              byte      %00000000               ' "
              byte      %00000000               ' #
              byte      %00000000               ' $
              byte      %00000000               ' %
              byte      %00000000               ' &
              byte      %00000010               ' '
              byte      %00000000               ' (
              byte      %00000000               ' )
              byte      %00000000               ' *
              byte      %00000000               ' +
              byte      %00000000               ' ,
              byte      %00000001               ' -
              byte      %00000000               ' .
              byte      %00000000               ' /
              byte      %01111110               ' 0
              byte      %00011000               ' 1
              byte      %01101101               ' 2
              byte      %00111101               ' 3
              byte      %00011011               ' 4
              byte      %00110111               ' 5
              byte      %01110111               ' 6
              byte      %00011100               ' 7
              byte      %01111111               ' 8
              byte      %00111111               ' 9
              byte      %00000000               ' :
              byte      %00000000               ' ;
              byte      %00000000               ' <
              byte      %00100001               ' =
              byte      %00000000               ' >    
              byte      %00000000               ' ?
              byte      %00000000               ' @
              byte      %01011111               ' A
              byte      %00000000               ' B
              byte      %01100110               ' C
              byte      %00000000               ' D 
              byte      %01100111               ' E
              byte      %01000111               ' F
              byte      %00000000               ' G
              byte      %01011011               ' H
              byte      %00011000               ' I
              byte      %01111000               ' J    
              byte      %00000000               ' K
              byte      %01100010               ' L
              byte      %00000000               ' M
              byte      %00000000               ' N
              byte      %01111110               ' O
              byte      %01001111               ' P
              byte      %00000000               ' Q 
              byte      %00000000               ' R
              byte      %00110111               ' S
              byte      %00000000               ' T
              byte      %01111010               ' U
              byte      %00000000               ' V    
              byte      %00000000               ' W
              byte      %00000000               ' X
              byte      %00111011               ' Y
              byte      %00000000               ' Z
              byte      %01100110               ' [
              byte      %00000000               ' \ 
              byte      %00111100               ' ]
              byte      %00000000               ' ^
              byte      %00100000               ' _
              byte      %00001000               ' `
              byte      %00000000               ' a
              byte      %01110011               ' b    
              byte      %01100001               ' c
              byte      %01111001               ' d
              byte      %00000000               ' e
              byte      %00000000               ' f
              byte      %00000000               ' g
              byte      %01010011               ' h
              byte      %00010000               ' i
              byte      %00000000               ' j
              byte      %00000000               ' k
              byte      %00001100               ' l
              byte      %00000000               ' m
              byte      %01010001               ' n    
              byte      %01110001               ' o
              byte      %00000000               ' p
              byte      %00000000               ' q
              byte      %01000001               ' r
              byte      %00000000               ' s
              byte      %01100011               ' t 
              byte      %01110000               ' u
              byte      %00000000               ' v
              byte      %00000000               ' w
              byte      %00000000               ' x
              byte      %00000000               ' y
              byte      %00000000               ' z    
              byte      %00011001               ' {
              byte      %00000000               ' |
              byte      %01000011               ' }
              byte      %00000000               ' ~
              byte      %00000000               ' blank

 